﻿using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace ILoan.Tools.Domain.Migrations
{
    /// <inheritdoc />
    public partial class CreateToolsSchema : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.EnsureSchema(
                name: "core");

            migrationBuilder.CreateTable(
                name: "Core_Rules",
                schema: "core",
                columns: table => new
                {
                    ID = table.Column<int>(type: "INTEGER", nullable: false)
                        .Annotation("Sqlite:Autoincrement", true),
                    RuleName = table.Column<string>(type: "TEXT", nullable: false),
                    Source = table.Column<string>(type: "TEXT", nullable: false),
                    DefaultThreshold = table.Column<decimal>(type: "TEXT", nullable: true),
                    Blocked = table.Column<bool>(type: "INTEGER", nullable: false),
                    TriggersManualReview = table.Column<bool>(type: "INTEGER", nullable: false),
                    SuggestedResolution = table.Column<string>(type: "TEXT", nullable: true),
                    TriggerReason = table.Column<string>(type: "TEXT", nullable: true),
                    UseLastRecord = table.Column<bool>(type: "INTEGER", nullable: true, defaultValueSql: "true"),
                    ApplicantType = table.Column<string>(type: "TEXT", nullable: true),
                    FilterOnClickthrough = table.Column<string>(type: "TEXT", nullable: true),
                    RunBeforeStatus = table.Column<string>(type: "TEXT", nullable: true),
                    DisplaySection = table.Column<string>(type: "TEXT", nullable: true),
                    WarningField = table.Column<string>(type: "TEXT", nullable: true),
                    DutchRuleName = table.Column<string>(type: "TEXT", nullable: false),
                    DutchTriggerReason = table.Column<string>(type: "TEXT", nullable: true),
                    DutchSuggestedResolution = table.Column<string>(type: "TEXT", nullable: true),
                    DutchFilterOnClickthrough = table.Column<string>(type: "TEXT", nullable: true),
                    RuleExplanation = table.Column<string>(type: "TEXT", nullable: true),
                    DutchRuleExplanation = table.Column<string>(type: "TEXT", nullable: true),
                    WorkItemId = table.Column<int>(type: "INTEGER", nullable: true),
                    Title = table.Column<string>(type: "TEXT", nullable: true),
                    Update = table.Column<int>(type: "INTEGER", nullable: false),
                    Scope = table.Column<string>(type: "TEXT", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Core_Rules", x => x.ID);
                });

            migrationBuilder.CreateTable(
                name: "Core_RuleCriteria",
                schema: "core",
                columns: table => new
                {
                    ID = table.Column<int>(type: "INTEGER", nullable: false)
                        .Annotation("Sqlite:Autoincrement", true),
                    RuleID = table.Column<int>(type: "INTEGER", nullable: true),
                    Property = table.Column<string>(type: "TEXT", nullable: true),
                    Comparison = table.Column<string>(type: "TEXT", nullable: true),
                    Value = table.Column<string>(type: "TEXT", nullable: true),
                    ValueIsProperty = table.Column<bool>(type: "INTEGER", nullable: true, defaultValueSql: "false"),
                    ReturnCount = table.Column<bool>(type: "INTEGER", nullable: true, defaultValueSql: "false"),
                    IsThresholdCriterium = table.Column<bool>(type: "INTEGER", nullable: true, defaultValueSql: "false"),
                    Update = table.Column<int>(type: "INTEGER", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Core_RuleCriteria", x => x.ID);
                    table.ForeignKey(
                        name: "FK_Core_RuleCriteria_Core_Rules_RuleID",
                        column: x => x.RuleID,
                        principalSchema: "core",
                        principalTable: "Core_Rules",
                        principalColumn: "ID");
                });

            migrationBuilder.CreateTable(
                name: "Core_RuleCriteriaOperator",
                schema: "core",
                columns: table => new
                {
                    ID = table.Column<int>(type: "INTEGER", nullable: false)
                        .Annotation("Sqlite:Autoincrement", true),
                    RuleID = table.Column<int>(type: "INTEGER", nullable: true),
                    Operator = table.Column<string>(type: "TEXT", nullable: true),
                    Update = table.Column<int>(type: "INTEGER", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Core_RuleCriteriaOperator", x => x.ID);
                    table.ForeignKey(
                        name: "FK_Core_RuleCriteriaOperator_Core_Rules_RuleID",
                        column: x => x.RuleID,
                        principalSchema: "core",
                        principalTable: "Core_Rules",
                        principalColumn: "ID");
                });

            migrationBuilder.CreateIndex(
                name: "IX_Core_RuleCriteria_RuleID",
                schema: "core",
                table: "Core_RuleCriteria",
                column: "RuleID");

            migrationBuilder.CreateIndex(
                name: "IX_Core_RuleCriteriaOperator_RuleID",
                schema: "core",
                table: "Core_RuleCriteriaOperator",
                column: "RuleID");
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropTable(
                name: "Core_RuleCriteria",
                schema: "core");

            migrationBuilder.DropTable(
                name: "Core_RuleCriteriaOperator",
                schema: "core");

            migrationBuilder.DropTable(
                name: "Core_Rules",
                schema: "core");
        }
    }
}
